package com.chinacreator.datasync;

import javax.sql.DataSource;

import com.alibaba.fastjson.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.scheduling.annotation.EnableScheduling;

/****
 * # SpringBoot中CommandLineRunner的作用
 * 平常开发中有可能需要实现在项目启动后执行的功能，SpringBoot提供的一种简单的实现方案就是添加一个model并实现CommandLineRunner接口，实现功能的代码放在实现的run方法中
 * @author xu.zhou
 */
@SpringBootApplication
@EnableScheduling
public class Application implements CommandLineRunner{

	public static void main(String[] args) {
		//SpringApplication.run(Application.class, args);
		new SpringApplicationBuilder().sources(Application.class).web(false).run(args);
	}
	@Autowired
    DataSource dataSource;

    @Override
    public void run(String... args) throws Exception {
     System.out.println("连接池=>"+dataSource.getClass()+" = " + dataSource);
    }
}
