package com.chinacreator.datasync.common;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.chinacreator.datasync.dao.QueryDbDao;
import com.chinacreator.datasync.entity.CpAccountBean;
import com.chinacreator.datasync.entity.CpSyncJobBean;
import com.chinacreator.datasync.entity.SpBean;
import com.chinacreator.datasync.entity.SpCpBean;
import com.chinacreator.datasync.util.AESUtil;

public class ConfigUtil {
	
	
	/**
	 * 查询cp对应账号信息
	 * 
	 * @param cpid
	 * @param dao
	 * @return
	 */
	public static Map<String,Object> map = new HashMap<String, Object>();
	public static CpAccountBean queryCpAccount(String cpid, QueryDbDao dao ){
    	CpAccountBean bean = null;
    	long key = System.currentTimeMillis();
    	
    	try {
    		Long key2 = (Long)map.get("key_"+cpid);
    		if(key2 != null && key2+3600000L > key){
    			bean = (CpAccountBean)map.get("val_"+cpid);
    		}else{
    			bean = dao.queryCpAccount(cpid);
    			if(bean != null) {
    				map.put("key_"+cpid,key);
    				map.put("val_"+cpid,bean);
    			}
    		}
    	} catch (Exception e) {}
    	
    	return bean;
    }
	
    /**
     * 查询产品信息
     * 
     * @param spid
     * @return
     */
    public static Map<String,Object> mapSp = new HashMap<String, Object>();
    public static SpBean queryBySpid(String spid, QueryDbDao dao ){
    	SpBean spbean = null;
    	long key = System.currentTimeMillis();
    	try {
    		Long key2 = (Long)mapSp.get("key_"+spid);
    		if(key2 != null && key2+3600000L > key){
    			spbean = (SpBean)mapSp.get("val_"+spid);
    		}else{
    			spbean = dao.queryBySpid(spid);
    			if(spbean != null) {
    				mapSp.put("key_"+spid,key);
    				mapSp.put("val_"+spid,spbean);
    			}
    		}
    	} catch (Exception e) {}
    	
    	return spbean;
    }
    
    /**
	 * 查询子产品信息
	 * 
	 * @param spid
	 * @param dao
	 * @return
	 */
	public static Map<String,Object> mapSpCp = new HashMap<String, Object>();
    public static List<SpCpBean> querySpCpBeans(String spid, QueryDbDao dao ){
    	List<SpCpBean> spCpBeans = null;
    	long key = System.currentTimeMillis();
    	
    	try {
    		Long key2 = (Long)mapSpCp.get("key_"+spid);
    		if(key2 != null && key2+3600000L > key){
    			spCpBeans = (List<SpCpBean>)mapSpCp.get("val_"+spid);
    		}else{
    			spCpBeans = dao.querySpCpBeans(spid);
    			if(spCpBeans != null) {
    				mapSpCp.put("key_"+spid,key);
    				mapSpCp.put("val_"+spid,spCpBeans);
    			}
    		}
    	} catch (Exception e) {}
    	
    	return spCpBeans;
    }
	
	/**
	 * 查询cp同步job配置
	 * @param online
	 * @param cpid
	 * @return
	 */
	public static Map<String,Object> mapJob = new HashMap<String, Object>();
	public static CpSyncJobBean querySyncJob(boolean online, String cpid, QueryDbDao dao){
		CpSyncJobBean bean = null;
    	long key = System.currentTimeMillis();
    	
    	try {
    		Long key2 = (Long)mapJob.get("key_"+cpid);
    		if(key2 != null && key2+3600000L > key){
    			bean = (CpSyncJobBean)mapJob.get("val_"+cpid);
    		}else{
    			bean = dao.queryCpSyncJob(cpid,online?"0":"1");
    			if(bean != null) {
    				mapJob.put("key_"+cpid,key);
    				mapJob.put("val_"+cpid,bean);
    			}
    		}
    	} catch (Exception e) {}
    	
    	return bean;
	}
	
	
	/**
	 * 用于科创伪码生产
	 */
	private static final String KEY = "ac22273abb2f4960";
	public static String getAesUserid(String userid ,String mobtype) {
		if("1".equals(mobtype)) {
			try {
				return AESUtil.encrypt(userid, KEY);
			} catch (Exception e) {}
		}
		return userid;
	}
	
	/**
	 * 查询优酷同步spid
	 * 
	 * @param userid
	 * @param spid
	 * @return
	 */
	public static String getYoutuSyncSpid(String cpid ,String spid, QueryDbDao dao) {
		String rSpid = spid;
//		if(!"22201".equals(spid) && !"1161".equals(spid) && !"1166".equals(spid) && !"1167".equals(spid) && !"21160".equals(spid) && !"21202".equals(spid)){
//			rSpid = "21156";
//			if("1168".equals(spid)){
//				rSpid = "1167";
//			}
//		}
		return rSpid;
	}
	
	
	/**
	 * 计算这个号码放入kafka那个分区
	 * 
	 * @param mobile
	 * @param partition
	 * @return
	 */
	public static int getPartition(String mobile,int partition) {
		int intSum = 0;
		char[] chr_num = mobile.toCharArray();
		for (int i = 0; i < chr_num.length; i++) {
			intSum += chr_num[i];
		}
		
		return intSum % partition;
	}


	/**
	 * 查询cp同步job配置
	 * @param online
	 * @param cpid
	 * @return
	 */
	public static Map<String,Object> mapFakeidsJob = new HashMap<String, Object>();
	public static CpSyncJobBean queryFakeidsSyncJob(String cpid, QueryDbDao dao){
		CpSyncJobBean bean = null;
		long key = System.currentTimeMillis();

		try {
			Long key2 = (Long)mapFakeidsJob.get("key_"+cpid);
			if(key2 != null && key2+3600000L > key){
				bean = (CpSyncJobBean)mapFakeidsJob.get("val_"+cpid);
			}else{
				bean = dao.queryCpSyncJob(cpid,"3");//伪码同步标识3
				if(bean != null) {
					mapFakeidsJob.put("key_"+cpid,key);
					mapFakeidsJob.put("val_"+cpid,bean);
				}
			}
		} catch (Exception e) {}

		return bean;
	}
}
