package com.chinacreator.datasync.fakeid;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;
import com.chinacreator.datasync.dao.QueryDbDao;
import com.chinacreator.datasync.util.MD5;
import com.chinacreator.datasync.util.URLUtil;


/**
 * 通过接口查询电商伪码
 * 
 * @author 科创·毛燕龙
 * @datetime 2019年4月11日 上午9:22:05
 */
public class CpFakeidUtil {
	
	public static String fakeidQuery(String userid,String cpid, String spid, QueryDbDao dao){
		if(!"bilibl".equals(cpid)) {
			CpFakeidBean bean = dao.findFakeidBean(userid, cpid);
			if (bean != null && bean.getFakeid() != null && !"".equals(bean.getFakeid().trim())) {
				return bean.getFakeid().trim();
			}
		}
		
		if("aiqy".equals(cpid)) {
			
			final String baseurl="http://123.125.99.7:9003/api";
			final String user="000025";
			final String pwd="8MwkN8wy7tr4";
			final String service="1";
			final String function="7";
			return getFakeidAiqy(userid, cpid, spid, baseurl, user, pwd, service, function,dao);
		}else if("youtu".equals(cpid) || "kuaishou".equals(cpid) || "yinlingka".equals(cpid)) {
			
			final String baseurl="https://pts.10010.com:9005/api";
			final String user="000101";
			final String pwd="9nBrS4BV967z";
			final String service="0";
			final String function="3";
			final String appid="339302416384";
			return getFakeidYouku(userid, cpid, spid, baseurl, user, pwd, service, function,appid,dao);
		}else if("bilibl".equals(cpid)){
            final String baseurl="http://124.64.196.11:9001/api";
            final String user="000217";
            final String pwd="g9J7Sb93Eiz8";
            final String service="1";
            final String function="1";
            final String appid="932007903232";
            return getFakeidBilibl(userid, cpid, spid, baseurl, user, pwd, service, function,appid,dao);
        } else if("keep".equals(cpid)){
			final String baseurl="http://124.64.196.11:9001/api";
			final String user="000361";
			final String pwd="VWv94kH383nU";
			final String service="1";
			final String function="1";
			final String appid="1550483193856";
			return getFakeidKeep(userid, cpid, spid, baseurl, user, pwd, service, function,appid,dao);
		}else {
			return "CPNULL";
		}
	}
	
	public static String getFakeidAiqy(String userid,String cpid,String spid ,String baseurl,String user,String pwd,String service,String function,QueryDbDao dao){
		try {
			
			Date curdate= new Date();
			
			String tick=(curdate.getTime()/1000)+"";
			String key=MD5.MD5Encode(user+tick+pwd).substring(0,16);
			
			Map<String,String> param = new HashMap<String,String>();
			param.put("user",user);
			param.put("tick",tick);
			param.put("key",key);
			param.put("service",service);
			param.put("function",function);
			param.put("mobile","86"+userid);
			
			String url = URLUtil.mapToUrl(baseurl,param);
			String resp = URLUtil.get(url);
			System.out.println(url+"###"+resp);
			
			try {
				CpFakeidLog log = new CpFakeidLog();
				String id = new SimpleDateFormat("yyyyMMddHHmmssSSS").format(new Date()) + String.valueOf((int)((Math.random()*9+1)*1000000));
				log.setId(id);
				log.setUserid(userid);
				log.setCpid(cpid==null?"":cpid);
				log.setSpid(spid==null?"":spid);
				log.setInputdata(url);
				log.setReturnrsp(resp==null?"":resp);
				dao.insertFakeidLog(log);
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			JSONObject resultObject = JSONObject.parseObject(resp);
    		String result = resultObject.getString("result");
    		String fakeid = resultObject.getString("pcode");
    		if("0".equals(result) && fakeid != null && !"".equals(fakeid)){
    			try {
    				CpFakeidBean bean = new CpFakeidBean();
    				bean.setUserid(userid);
    				bean.setCpid(cpid);
    				bean.setFakeid(fakeid);
    				dao.insertFakeidBean(bean);
				} catch (Exception e) {
					e.printStackTrace();
				}
    			return fakeid;
    		}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return null;
	}
	
	
	
	public static String getFakeidYouku(String userid,String cpid,String spid ,String baseurl,String user,String pwd,String service,String function,String appid,QueryDbDao dao){
		try {
			Date curdate= new Date();
			
			String tick=(curdate.getTime()/1000)+"";
			String key=MD5.MD5Encode(user+tick+pwd).substring(0,16);
			
			Map<String,String> param = new HashMap<String,String>();
			param.put("user",user);
			param.put("tick",tick);
			param.put("key",key);
			param.put("service",service);
			param.put("function",function);
			param.put("mobile","86"+userid);
			param.put("appid",appid);
			
			String url = URLUtil.mapToUrl(baseurl,param);
			String resp = URLUtil.get(url);
//			System.out.println(url+"###"+resp);
			
			try {
				CpFakeidLog log = new CpFakeidLog();
				String id = new SimpleDateFormat("yyyyMMddHHmmssSSS").format(new Date()) + String.valueOf((int)((Math.random()*9+1)*1000000));
				log.setId(id);
				log.setUserid(userid);
				log.setCpid(cpid==null?"":cpid);
				log.setSpid(spid==null?"":spid);
				log.setInputdata(url);
				log.setReturnrsp(resp==null?"":resp);
				dao.insertFakeidLog(log);
			} catch (Exception e) {
				e.printStackTrace();
			}
			
			JSONObject resultObject = JSONObject.parseObject(resp);
			String result = resultObject.getString("result");
			String fakeid = resultObject.getString("pcode");
			if("0".equals(result) && fakeid != null && !"".equals(fakeid)){
				try {
					CpFakeidBean bean = new CpFakeidBean();
					bean.setUserid(userid);
					bean.setCpid(cpid);
					bean.setFakeid(fakeid);
					dao.insertFakeidBean(bean);
				} catch (Exception e) {
					e.printStackTrace();
				}
				return fakeid;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return null;
	}

    public static String getFakeidBilibl(String userid,String cpid,String spid ,String baseurl,String user,String pwd,String service,String function,String appid,QueryDbDao dao){
        try {
            Date curdate= new Date();

            String tick=(curdate.getTime()/1000)+"";
            String key=MD5.MD5Encode(user+tick+pwd).substring(0,16);

            Map<String,String> param = new HashMap<String,String>();
            param.put("user",user);
            param.put("tick",tick);
            param.put("key",key);
            param.put("service",service);
            param.put("function",function);
            param.put("mobile","86"+userid);
            param.put("appid",appid);

            String url = URLUtil.mapToUrl(baseurl,param);
            String resp = URLUtil.get(url);
//			System.out.println(url+"###"+resp);

            try {
                CpFakeidLog log = new CpFakeidLog();
                String id = new SimpleDateFormat("yyyyMMddHHmmssSSS").format(new Date()) + String.valueOf((int)((Math.random()*9+1)*1000000));
                log.setId(id);
                log.setUserid(userid);
                log.setCpid(cpid==null?"":cpid);
                log.setSpid(spid==null?"":spid);
                log.setInputdata(url);
                log.setReturnrsp(resp==null?"":resp);
                dao.insertFakeidLog(log);
            } catch (Exception e) {
                e.printStackTrace();
            }

            JSONObject resultObject = JSONObject.parseObject(resp);
            String result = resultObject.getString("result");
            String fakeid = resultObject.getString("pcode");
            if("0".equals(result) && fakeid != null && !"".equals(fakeid)){
                try {
                    CpFakeidBean bean = new CpFakeidBean();
                    bean.setUserid(userid);
                    bean.setCpid(cpid);
                    bean.setFakeid(fakeid);
                    dao.insertBiliblFakeidBean(bean);
                }catch (Exception e){
                    e.printStackTrace();
                }
                return fakeid;//不进行截断了
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return null;
    }

	public static String getFakeidKeep(String userid, String cpid, String spid, String baseurl, String user, String pwd, String service, String function,String appid, QueryDbDao dao){
		try {

			Date curdate= new Date();

			String tick=(curdate.getTime()/1000)+"";
			String key=MD5.MD5Encode(user+tick+pwd).substring(0,16);

			Map<String,String> param = new HashMap<String,String>();
			param.put("user",user);
			param.put("tick",tick);
			param.put("key",key);
			param.put("service",service);
			param.put("function",function);
			param.put("mobile","86"+userid);
			param.put("appid",appid);

			String url = URLUtil.mapToUrl(baseurl,param);
			String resp = URLUtil.get(url);
			System.out.println(url+"###"+resp);

			try {
				CpFakeidLog log = new CpFakeidLog();
				String id = new SimpleDateFormat("yyyyMMddHHmmssSSS").format(new Date()) + String.valueOf((int)((Math.random()*9+1)*1000000));
				log.setId(id);
				log.setUserid(userid);
				log.setCpid(cpid==null?"":cpid);
				log.setSpid(spid==null?"":spid);
				log.setInputdata(url);
				log.setReturnrsp(resp==null?"":resp);
				dao.insertFakeidLog(log);
			} catch (Exception e) {
				e.printStackTrace();
			}

			JSONObject resultObject = JSONObject.parseObject(resp);
			String result = resultObject.getString("result");
			String fakeid = resultObject.getString("pcode");
			if("0".equals(result) && fakeid != null && !"".equals(fakeid)){
				try {
					CpFakeidBean bean = new CpFakeidBean();
					bean.setUserid(userid);
					bean.setCpid(cpid);
					bean.setFakeid(fakeid);
					dao.insertFakeidBean(bean);
				} catch (Exception e) {
					e.printStackTrace();
				}
				return fakeid;
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		return null;
	}
	
	public static void main(String[] args) {
//		String dd = CpFakeidUtil.getFakeidFromUnicom("17611100414", null);
//		System.out.println(dd);
		
	}

}
