package com.chinacreator.datasync.handler;

import com.chinacreator.datasync.common.ConfigUtil;
import com.chinacreator.datasync.dao.QueryDbDao;
import com.chinacreator.datasync.entity.OrderBean;
import com.chinacreator.datasync.entity.SpCpBean;
import org.slf4j.Logger;
import org.springframework.beans.BeanUtils;

import java.util.List;

/**
 * 
 * 复合产品伪码同步
 * 
 * @author zhengrong.yan
 *
 */
public class SyncFakeidsMultiHandler extends SyncFakeidsCommonHandler {

	public static String fakeCpids = ",bilibl,";
	
	@Override
	public boolean doSyncFakeids(OrderBean bean, QueryDbDao dao, Logger logger) throws Exception {
		List<SpCpBean> spCpBeans = ConfigUtil.querySpCpBeans(bean.getSpid(), dao);
		if(spCpBeans != null && spCpBeans.size()>0) {

			//放入kafka队列
			boolean result = true;
			logger.info("要推送到kafka的数据条数"+(spCpBeans != null ? spCpBeans.size(): "0")+bean.getUserid()+", "+bean.getSpid());
			for(SpCpBean spCpBean : spCpBeans) {
				OrderBean order = new OrderBean();
				BeanUtils.copyProperties(bean, order);
				//复合产品每次重新获取fakeids
				String fakeids = dao.getNowfakeids(bean.getOrderid());
				order.setFakeids(fakeids);
				order.setCpid(spCpBean.getCpid());
				order.setSpid(spCpBean.getProductid());
				if (fakeCpids.contains("," + order.getCpid() + ",")) {
					logger.info("开始添加数据到kafka，"+bean.getUserid()+", "+order.getSpid());
					boolean res = synFakeids(order, 3, bean.getCpid(), bean.getSpid(), dao, logger);
					logger.info("添加结果："+res+", "+bean.getUserid());
					if(!res) {
						result = false;
						break;
					}
				}else{
					logger.info("复合产品此cpid不需要推送给cp方："+order.getCpid()+", "+bean.getUserid());
				}
			}
			
			return result;
			
		}else {
			return false;
		}
		
	}
}
