package com.chinacreator.datasync.handler;

import java.util.List;

import org.slf4j.Logger;
import org.springframework.beans.BeanUtils;

import com.chinacreator.datasync.common.ConfigUtil;
import com.chinacreator.datasync.dao.QueryDbDao;
import com.chinacreator.datasync.entity.OrderBean;
import com.chinacreator.datasync.entity.SpCpBean;

/**
 * 
 * 复合产品同步
 * 
 * @author maoya
 *
 */
public class SyncOrderMultiHandler extends SyncOrderCommonHandler  {
	
	@Override
	public boolean doSyncOrder(OrderBean bean, QueryDbDao dao, Logger logger) throws Exception {
		List<SpCpBean> spCpBeans = ConfigUtil.querySpCpBeans(bean.getSpid(), dao);
		if(spCpBeans != null && spCpBeans.size()>0) {
			//保存同步标记数据
			int i=0;
			if("0".equals(bean.getCdnflag())) {
//				logger.info("添加CDN待同步数据到表TD_DATA_SYNC_WAIT"+bean.getUserid()+", "+bean.getSpid());
//				i=dao.insertSyncFlagBeansCdn(bean.getSyncid(), bean.getId(), bean.getUserid(), bean.getSpid());
			}else {
				logger.info("添加CP待同步数据到表TD_DATA_SYNC_WAIT"+bean.getUserid()+", "+bean.getSpid());
				i=dao.insertSyncFlagBeans(bean.getSyncid(), bean.getId(), bean.getUserid(), bean.getSpid());
			}
			
			if(i<=0) {
				logger.info("添加到表TD_DATA_SYNC_WAIT失败，"+bean.getUserid());
				return false;
			}
			
			//放入kafka队列
			boolean result = true;
			logger.info("要推送到kafka的数据条数"+(spCpBeans != null ? spCpBeans.size(): "0")+bean.getUserid()+", "+bean.getSpid());
			for(SpCpBean spCpBean : spCpBeans) {
				OrderBean order = new OrderBean();
				BeanUtils.copyProperties(bean, order);
				//复合产品每次重新获取fakeids
				String fakeids = dao.getNowfakeids(bean.getId());
				order.setFakeids(fakeids);
				order.setCpid(spCpBean.getCpid());
				order.setSpid(spCpBean.getProductid());
				logger.info("开始添加数据到kafka，"+bean.getUserid()+", "+order.getSpid());
				boolean res = syncOrder(order, 3, bean.getCpid(), bean.getSpid(), dao, logger);
				logger.info("添加结果："+res+", "+bean.getUserid());
				if(!res) {
					result = false;
					break;
				}
			}
			
			return result;
			
		}else {
			return false;
		}
		
	}
	
	

}
