package com.chinacreator.datasync.handler.process;

import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.slf4j.Logger;

import com.chinacreator.datasync.common.ConfigUtil;
import com.chinacreator.datasync.dao.QueryDbDao;
import com.chinacreator.datasync.entity.CpAccountBean;
import com.chinacreator.datasync.entity.OrderBean;
import com.chinacreator.datasync.entity.OrderSyncKafkaBean;
import com.chinacreator.datasync.util.DesUtil;

/**
 * 
 * 整理放入kafka的数据
 * 
 * @author maoya
 *
 */
public class CommonSyncOrderProcessor implements ISyncOrderProcessor {
	
	@Override
	public OrderSyncKafkaBean toCPSyncOrderInfo(OrderBean orderBean, int ordertype, QueryDbDao dao, Logger logger) throws Exception {
		CpAccountBean cpAccountBean=ConfigUtil.queryCpAccount(orderBean.getCpid(), dao);
		
		SimpleDateFormat sdf=new SimpleDateFormat("yyyyMMddHHmmss");
		String ordertime=sdf.format(orderBean.getOrdertime());
		String canceltime="";
		String endtime="";
		String channelcode = orderBean.getOrderchannel() == null || "null".equals(orderBean.getOrderchannel()) ? "" : orderBean.getOrderchannel();
		if(orderBean.getCanceltime() != null){
			canceltime=sdf.format(orderBean.getCanceltime());
		}
		if(orderBean.getEndtime() != null) {
			endtime=sdf.format(orderBean.getEndtime());
		}
		
		OrderSyncKafkaBean syncOrderInfo = new OrderSyncKafkaBean();
		syncOrderInfo.setSyncid(orderBean.getSyncid());
		syncOrderInfo.setId(orderBean.getId());
		syncOrderInfo.setCpid(orderBean.getCpid());
		syncOrderInfo.setSpid(orderBean.getSpid());
		syncOrderInfo.setOrdertime(ordertime);
		syncOrderInfo.setType(orderBean.getStatus());
		syncOrderInfo.setProvince(orderBean.getProvince() == null ? "" : orderBean.getProvince());
		syncOrderInfo.setArea(orderBean.getArea() == null ?"" : orderBean.getArea());
		syncOrderInfo.setCanceltime(canceltime);
		syncOrderInfo.setEndtime(endtime);
		syncOrderInfo.setVideoid(orderBean.getVideoid() == null ? "" : orderBean.getVideoid());

		String usermob = URLEncoder.encode(DesUtil.encode(ConfigUtil.getAesUserid(orderBean.getUserid(), cpAccountBean.getMobtype()), cpAccountBean.getNetPwd()),"UTF-8");
		syncOrderInfo.setUsermob(usermob);
		syncOrderInfo.setUserid(orderBean.getUserid());
		syncOrderInfo.setChannelcode(channelcode);
		syncOrderInfo.setOrdertype(ordertype + "");
		syncOrderInfo.setFakeid(orderBean.getFakeid());
		syncOrderInfo.setFakeidmonth((new SimpleDateFormat("YYYYMM").format(new Date())));
		
		String id = orderBean.getId();
		id = id.substring(id.length()-10, id.length());
		syncOrderInfo.setValid(Long.parseLong(id));
		
		return syncOrderInfo;
	}
	
    

}
