package com.chinacreator.datasync.handler.process;

import java.util.HashMap;
import java.util.Map;

/**
 * 
 * 同步入队列数据处理，
 * 
 * @author maoya
 *
 */
public class SyncOrderProcessor {
	private static SyncOrderProcessor instance = new SyncOrderProcessor();

	private static Map<String, ISyncOrderProcessor> processors = new HashMap<String, ISyncOrderProcessor>();
	private ISyncOrderProcessor syncOrderProcessor = new CommonSyncOrderProcessor();

	static {
//		processors.put("xunlei", new XunleiSyncOrderProcessor());
//		processors.put("xunleikk", new XunleiSyncOrderProcessor());
		processors.put("youtu", new YoutuSyncOrderProcessor());
	}

	private SyncOrderProcessor() {
		super();
	}

	public static SyncOrderProcessor getInstance() {
		return instance;
	}

	public ISyncOrderProcessor getSyncOrderProcessor(String cpid) {
		if (processors.containsKey(cpid)) {
			return processors.get(cpid);
		}
		return syncOrderProcessor;
	}
}
