package com.chinacreator.datasync.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.alibaba.druid.util.StringUtils;
import com.chinacreator.datasync.dao.MatchChannelDbDao;
import com.chinacreator.datasync.entity.OrderBean;

/**
 * 替换渠道标识
 * 柏源CP同步要把子渠道标识对应的key当作渠道标识传值给CP方
 * @author xu.zhou
 * @date 20211118
 */
@Component
public class ReplaceChannelService {
	
	@Autowired 
	private MatchChannelDbDao matchChannelDbDao;

	public void replaceChannel(OrderBean orderBean){
		try {
			//订购渠道是boyuan，且orderchannel2不为空，退订和退订都传订购渠道的标识，与当前同步保持一致
			if("boyuan".equals(orderBean.getOrderchannel()) && !StringUtils.isEmpty(orderBean.getOrderchannel2())){
				//获取子渠道对应的key
				String subchannelkey = matchChannelDbDao.getSubchannelKey(orderBean.getOrderchannel2());
				if(!StringUtils.isEmpty(subchannelkey)){
					//替换订购渠道为key
					orderBean.setOrderchannel(subchannelkey);
				}			
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
